Page MenuHomePhabricator

Allow access to a disabled CX beta feature when navigating from an enabled CX beta feature
Closed, ResolvedPublic

Description

Translations in Content Translation (CX) involve two languages. When creating a new translation, CX redirects the user to the target Wikipedia so that articles are created locally.

This means that a user in the Spanish Wikipedia CX dashboard can start a translation from Spanish to Catalan, and, as a result, he will be redirected to Catalan Wikipedia's CX translate editor. This redirect allows CX to present an integrated view of all translations (the user does not have to figure out which site they should start a translation from) while avoiding cross-wiki saving issues.

When CX is isolated as a beta feature, the redirect may be problematic since the user needs to have the beta feature enabled for each of the languages involved. If that is not the case, the user will get a page not found error instead which will break the user experience badly.

To avoid this issue, we can allow access CX even if the beta feature is disabled only in the case of being part of the described redirection. The rationale is that the user has already enabled the beta feature on a site, and is clearly expressing the intent to start a new translation for which reaching CX will provide less surprise than getting an error message.

Acceptance criteria:

  • When coming using a link from a wiki where CX is enabled, the SpecialPage will work as if the beta feature is enabled in the target wiki.
  • The beta feature will not become actually enabled in the preferences in the target wiki and will not be otherwise available unless explicitly enabled.

Event Timeline

Pginer-WMF raised the priority of this task from to Needs Triage.
Pginer-WMF updated the task description. (Show Details)
Pginer-WMF changed Security from none to None.
Pginer-WMF added a subscriber: Pginer-WMF.

It should not be listed in Special pages list. If all URL parameters present, open it up.

This was communicated to Erik and product team too in email

Using Referer is another option to explore

Would it be possible to use the referrer to determine if we should allow access instead of a query param?

Amire80 updated the task description. (Show Details)Dec 10 2014, 2:29 PM
Amire80 removed a subscriber: Jsahleen.
Arrbee triaged this task as High priority.Dec 10 2014, 2:29 PM
Arrbee updated the task description. (Show Details)
santhosh claimed this task.Dec 10 2014, 4:07 PM
santhosh moved this task from Backlog to In Progress on the LE-Sprint-80 board.Dec 11 2014, 10:09 AM

Change 179115 had a related patch set uploaded (by Santhosh):
Override beta feature preference if Special:CX accessed with valid token

https://gerrit.wikimedia.org/r/179115

Patch-For-Review

santhosh moved this task from In Progress to In Review on the LE-Sprint-80 board.Dec 15 2014, 6:59 AM

Change 179115 merged by jenkins-bot:
Override beta feature preference if Special:CX accessed with valid token

https://gerrit.wikimedia.org/r/179115

Arrbee closed this task as Resolved.Dec 22 2014, 2:39 PM
Arrbee moved this task from In Review to Done on the LE-Sprint-80 board.
RandomDSdevel updated the task description. (Show Details)Mar 2 2015, 9:43 PM